<script>
import {useStore} from "vuex";
import ProductService from "@/service/ProductService";
import {HOST_API} from "@/vars";
import EventBus from '@/utils/event-bus.js';

export default {
  name: 'CategoryDetail',
  setup() {
    const store = useStore()
    return {
      store,
    }
  },
  data: () => ({
    category: null,
    id: null,
    submitted: false,
    show_form: false,
    method: null,
    role: null
  }),
  async created() {

    this.id = this.$route.params.id;

    this.role = this.store.state.profile.role

    if (this.id) {
      await this.getCategoryDetail(this.id)
    }

    this.$watch(
        () => this.$route.params,
        async (toParams, previousParams) => {
          await this.getCategoryDetail(toParams.id)
        }
    );
  },
  computed: {
    isAdmin() {
      if (this.role) {
        return this.store.state.admin.includes(this.role)
      }
    },
  },
  methods: {
    async getCategoryDetail(id) {
      if (!id) return
      this.id = id;
      const response = await fetch(HOST_API + `/categories/${id}/`, {
        method: 'GET',
        headers: {
          'Content-Type': 'application/json',
          'Authorization': `Bearer ${this.store.state.authentication.access}`,
        }
      })
      this.category = await response.json()
    },

    updateCategory() {
      this.method = "PUT";
      this.requestFetch()
    },

    requestFetch() {
      if(!this.isAdmin) {
        return
      }

      fetch(HOST_API + `/categories/${this.id}/`, {
        method: this.method,
        body: JSON.stringify(this.category),
        headers: {
          'Content-Type': 'application/json',
          'Authorization': `Bearer ${this.store.state.authentication.access}`,
        }
      }).then(res => {
        EventBus.emit('updated-categories', true)
        if(this.method === "DELETE") {
          this.$router.push({name: 'categories_list'});
        } else {
          res.json().then(response => {
            console.log(response)

          }).catch(err => {
            console.log(err)
          })
        }
      })
    },

    deleteCategory() {
      this.method = "DELETE"
      this.requestFetch()
    }

  }
}
</script>

<template>
  <div class="grid">
    <div class="col-12 xl:col-12">
      <div class="card">
        <div class="surface-section">
          <div class="font-medium text-3xl text-900 mb-3">Información de la categoría</div>
          <div class="text-500 mb-5">A continuación puede editar el título de la categoría</div>
          <ul class="list-none p-0 m-0" v-if="category">
            <li class="flex align-items-center py-3 px-2 border-top-1 surface-border flex-wrap">
              <div class="text-500 w-6 md:w-2 font-medium">Título</div>
              <div class="text-900 w-full md:w-8 md:flex-order-0 flex-order-1" style="margin-top: 20px">
                <div class="field">
                  <InputText :id="category.name" v-model.trim="category.name" required="true" autofocus
                             :class="{ 'p-invalid': submitted && !category.name }"/>
                  <small class="p-invalid" v-if="submitted && !category.name">Título es requerido.</small>
                </div>
              </div>
            </li>

            <li class="pt-5" v-if="isAdmin">
              <Button @click="deleteCategory" label="Eliminar" class="p-button-outlined p-button-danger mr-2 mb-2"/>
              <Button @click="updateCategory" label="Guardar" class="p-button-outlined p-button-info mr-2 mb-2"/>
            </li>
          </ul>
        </div>
      </div>

    </div>
  </div>
</template>
